unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeProcs, TeEngine, Chart, ExtCtrls, Math,

  TeeSurfa, StdCtrls, TeeComma;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Chart1: TChart;
    StopBtn: TButton;
    DisplayBtn: TButton;
    Label1: TLabel;
    MinLbl: TLabel;
    MaxLbl: TLabel;
    Memo1: TMemo;
    ExitBtn: TButton;
    TeeCommander1: TTeeCommander;
    procedure FormCreate(Sender: TObject);
    procedure DisplayBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
  private
    { Private declarations }

    ImageData : array of array of double;
    AngleData : array of double;
    Angle : double;
    xData, yData : array of double;
    fd : File of double;
    MinAngle : double;
    MaxAngle : double;
    Stopping : Boolean;
    procedure ReadData;


  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
const
  PaletteMin = -55;
  PaletteIncr = 1;
  PaletteSteps = 20;

  //...
  //...Just some colors for the pallette
  //...
  DefaultColorPalette : Array[1..256] of TColor = (
    $000000, $500000, $A00000, $100000, $150000, $1A0000, $200000, $250000, $2A0000,
    $300000, $350000, $3A0000, $400000, $450000, $4A0000, $500000, $550000, $5A0000,
    $600000, $650000, $6A0000, $700000, $750000, $7A0000, $800000, $850000, $8A0000,
    $900000, $950000, $9A0000, $A00000, $A50000, $AA0000, $B00000, $B50000, $BA0000,
    $C00000, $C50000, $CA0000, $D00000, $D50000, $DA0000, $E00000, $E50000, $EA0000,
    $F00000, $F50000, $FA0000, $FF0000, $0F5F00, $0FAF00, $FF1000, $FF1500, $FF1A00,
    $FF2000, $FF2500, $FF2A00, $FF3000, $FF3500, $FF3A00, $FF4000, $FF4500, $FF4A00,
    $FF5000, $FF5500, $FF5A00, $FF6000, $FF6500, $FF6A00, $FF7000, $FF7500, $FF7A00,
    $FF8000, $FF8500, $FF8A00, $FF9000, $FF9500, $FF9A00, $FFA000, $FFA500, $FFAA00,
    $FFB000, $FFB500, $FFBA00, $FFC000, $FFC500, $FFCA00, $FFD000, $FFD500, $FFDA00,
    $FFE000, $FFE500, $FFEA00, $FFF000, $FFF500, $FFFA00, $FFFF00, $FAFF00, $F5FF00,
    $F0FF00, $EAFF00, $E5FF00, $E0FF00, $DAFF00, $D5FF00, $D0FF00, $CAFF00, $C5FF00,
    $C0FF00, $BAFF00, $B5FF00, $B0FF00, $AAFF00, $A5FF00, $A0FF00, $9AFF00, $95FF00,
    $90FF00, $8AFF00, $85FF00, $80FF00, $7AFF00, $75FF00, $70FF00, $6AFF00, $65FF00,
    $60FF00, $5AFF00, $55FF00, $50FF00, $4AFF00, $45FF00, $40FF00, $3AFF00, $35FF00,
    $30FF00, $2AFF00, $25FF00, $20FF00, $1AFF00, $15FF00, $10FF00, $0AFF00, $05FF00,
    $00FF00, $00FF05, $00FF0A, $00FF10, $00FF15, $00FF1A, $00FF20, $00FF25, $00FF2A,
    $00FF30, $00FF35, $00FF3A, $00FF40, $00FF45, $00FF4A, $00FF50, $00FF55, $00FF5A,
    $00FF60, $00FF65, $00FF6A, $00FF70, $00FF75, $00FF7A, $00FF80, $00FF85, $00FF8A,
    $00FF90, $00FF95, $00FF9A, $00FFA0, $00FFA5, $00FFAA, $00FFB0, $00FFB5, $00FFBA,
    $00FFC0, $00FFC5, $00FFCA, $00FFD0, $00FFD5, $00FFDA, $00FFE0, $00FFE5, $00FFEA,
    $00FFF0, $00FFF5, $00FFFF, $00FAFF, $00F5FF, $00F0FF, $00EAFF, $00E5FF, $00E0FF,
    $00DAFF, $00D5FF, $00D0FF, $00CAFF, $00C5FF, $00C0FF, $00BAFF, $00B5FF, $00B0FF,
    $00AAFF, $00A5FF, $00A0FF, $009AFF, $0095FF, $0090FF, $008AFF, $0085FF, $0080FF,
    $007AFF, $0075FF, $0070FF, $006AFF, $0065FF, $0060FF, $005AFF, $0055FF, $0050FF,
    $004AFF, $0045FF, $0040FF, $003AFF, $0035FF, $0030FF, $002AFF, $0025FF, $0020FF,
    $001AFF, $0015FF, $0010FF, $000AFF, $0005FF, $0000FF, $1111FF, $2222FF, $3333FF,
    $4444FF, $5555FF, $6666FF, $7777FF, $8888FF, $9999FF, $AAAAFF, $BBBBFF, $CCCCFF,
    $DDDDFF, $EEEEFF, $FFFFFF, $FFFFFF);



procedure TForm1.ReadData;
var
  i : integer;

begin
//  SetLength(AngleData, Length(AngleData)+1);
//  blockread(fd, AngleData[High(AngleData)], 1);

  for i := 0 to 400 do
    if not eof(fd) then
      blockread(fd, yData[i], 1);

end;



procedure TForm1.DisplayBtnClick(Sender: TObject);
var
  i, j : integer;
  BlkCnt : integer;
  cnt : integer;
  fChartSteps : integer;
  tmpstr : string;

begin
  Stopping := False;
  //...
  //...Clear previous values in the chart.
  //...
  Chart1[0].Clear;

  //...
  //...Clear axis lables for scrolling
  //...
  //Chart1.Axes.Bottom.Items.Clear;

  // Set the number of columns before scrolling begins.
  fChartSteps := 100;
  if Length(ImageData) <> fChartSteps then
    SetLength(ImageData, fChartSteps);

  //...
  //...Prepare to read the data in.  401 samples per column or strip.
  //...
  SetLength(yData, 401);
  tmpstr := ExtractFilePath(ParamStr(0)) + 'Data.bin';
  system.Assign(fd, tmpstr);
  if not FileExists(tmpstr) then
    begin
      MessageDlg('Data file not found:'+#13#13+tmpstr, mtError, [mbOK], 0);
      Application.Terminate;
    end
  else
    system.Reset(fd);

  try
    for BlkCnt := 1 to fChartSteps do
      begin
        if Stopping then
          break;
        
        Label1.Caption := 'Block Cnt: '+IntToStr(BlkCnt);

        if Length(ImageData[BlkCnt-1]) < Length(yData) then
          SetLength(ImageData[BlkCnt-1], Length(yData));

        // Read the data in.  
        ReadData;

        Chart1.Series[0].BeginUpdate;

        for j := 0 to High(yData) do
          begin
            //...
            //...Save data for scrolling the display later.
            //...
            ImageData[BlkCnt-1,j] := yData[j];

            //...
            //...Add the labels for the column of data but add it only when the
            //...first data point (j = 0) is put in.  And only add them every 10 columns.
            //...
            if (j = 0) and ((BlkCnt-1) mod 10 = 0) then
              begin
                //
                //  CHANGE this it false to see the plot work properly.
                //
                if true then
                  begin
                    //...
                    //...Not sure how to set LabelStyle
                    //...
                    Chart1.Axes.Left.LabelStyle:=talText;
                    Chart1.Axes.Bottom.LabelStyle:=talText;
  //                  Chart1.Axes.Top.LabelStyle:=talValue;
  //                  Chart1.Axes.Bottom.LabelStyle:=talValue;

                    //...
                    //...SetMinMax based on angle data currently being displayed.
                    //...
                    Chart1.Axes.Top.SetMinMax(AngleData[0], AngleData[BlkCnt-1]);

                    //... Display current Min/Max
                    MinLbl.Caption := 'Min Az: '+FloatToStr(AngleData[0]);
                    MaxLbl.Caption := 'Max Az: '+FloatToStr(AngleData[BlkCnt-1]);

                    //...Add current angle.
                    //Chart1.Axes.Bottom.Items.add(BlkCnt-1,Format('%-.2f',[AngleData[BlkCnt-1]]));
                  end
                else
                  //Chart1.Axes.Bottom.Items.add(BlkCnt);
              end;

            //...
            //...Add the data to the chart.
            //...
            (Chart1[0] as TColorGridSeries).AddXYZ(BlkCnt-1, yData[j], j,
                            Format('%-.2f',[AngleData[BlkCnt-1]]), clTeeColor);

            // Only draw the left axis once.  xData contains the axis labels that were
            // calculated below.
            if BlkCnt = 1 then
              begin
                Chart1.Axes.Right.SetMinMax(xData[0], xData[High(xData)]);
                if (j mod (Length(ImageData[0]) Div 1) = 0) then
                  Chart1.Axes.Left.Items.add(j,Format('%-.2f',[xData[j]]));
              end;
          end;

        Chart1.Series[0].EndUpdate;
        application.ProcessMessages;

        // This is just a delay so you can see things working then go wrong on the screen
        Sleep(20);
      end;

    //...
    //...Now start to scroll the screen.
    //...
    for BlkCnt := fChartSteps+1 to 500 do
      begin
        if Stopping then
          break;

        Label1.Caption := 'Block Cnt: '+IntToStr(BlkCnt);

        //...
        //...Clear previous 100 columns values in the chart.
        //...
        Chart1[0].Clear;

        //...
        //...Clear axis lables for scrolling
        //...
      //Chart1.Axes.Bottom.Items.Clear;

      Chart1.Series[0].BeginUpdate;

        //...
        //...Not sure how to set LabelStyle
        //...
        Chart1.Axes.Top.LabelStyle := talText;
        Chart1.Axes.Bottom.LabelStyle := talText;
//      Chart1.Axes.Top.LabelStyle := talValue;
//      Chart1.Axes.Bottom.LabelStyle := talValue;

        //...
        //...Shift the x axis label values.
        //...
        for i := 0 to High(ImageData)-1 do
          begin
            if True then
              begin
                if (i=0) then
                  begin
                    //............................................................
                    //...
                    //...   Try commenting the Top.SetMinMax line and
                    //...   uncommenting the Bottom.SetMinMax line
                    //...
//                    Chart1.Axes.Top.SetMinMax(AngleData[BlkCnt-fChartSteps], AngleData[BlkCnt-1]);
//                    Chart1.Axes.Bottom.SetMinMax(AngleData[BlkCnt-fChartSteps], AngleData[BlkCnt-1]);
                    //...
                    //...  With Top.SetMinMax line uncommented, the scrolling data works fine.
                    //...  With Bottom.SetMinMax uncommented, the nothing works.
                    //...  I know Top is the wrong one, but it is closer!
                    //...
                    //...
                    //............................................................

                    MinLbl.Caption := 'Min Az: '+FloatToStr(AngleData[BlkCnt-fChartSteps]);
                    MaxLbl.Caption := 'Max Az: '+FloatToStr(AngleData[BlkCnt-1]);
                  end;

                //Chart1.Axes.Bottom.Items.add(PlotParam.AngleData[i+BlkCnt-fChartSteps]);
                //Chart1.Axes.Bottom.Items.add(i, Format('%-.2f',[AngleData[i+BlkCnt-fChartSteps]]));
              end
            else
              //Chart1.Axes.Bottom.Items.add(i+BlkCnt-fChartSteps);

            //...
            //...Now shift the data to give the strip chart effect.
            //...
            for j := 0 to High(ImageData[0]) do
              begin
                ImageData[i,j] := ImageData[i+1,j];
                (Chart1[0] as TColorGridSeries).AddXYZ(i+BlkCnt-fChartSteps,
                              ImageData[i,j],
                              j,
                              Format('%-.2f',[AngleData[i+BlkCnt-fChartSteps]]),
                              clTeeColor);
              end;
          end;

{        if True then
          Chart1.Axes.Bottom.Items.add(i, Format('%-.2f',[AngleData[High(AngleData)]]))
        else
          Chart1.Axes.Bottom.Items.add(i+BlkCnt-fChartSteps);
}
        //...
        //...Read another block of data.
        //...
        ReadData;

        //...
        //...Save and display the new block of data.
        //...
        i := High(ImageData);
        for j := 0 to High(Ydata) do
          begin
            ImageData[i,j] := yData[j];
            (Chart1[0] as TColorGridSeries).AddXYZ((i+BlkCnt-fChartSteps),
                                  ImageData[i,j],
                                  j,
                                  //Format('%-.2f',[AngleData[High(AngleData)]]),
                                  Format('%-.2f',[AngleData[i+BlkCnt-fChartSteps]]),
                                  clTeeColor);
          end;

        Chart1[0].EndUpdate;
        application.ProcessMessages;

//      // This is just a delay so you can see things working then go wrong on the screen
//      Sleep(20);
      end;

  finally
    CloseFile(fd);
  end;

end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i, j, k, l, m  : integer;

begin
  Chart1.ClearChart;

  //...
  //...Set up the strip chart
  //...
  Chart1.AddSeries(TColorGridSeries.Create(Application));
  Chart1.View3D := False;
  Chart1[0].Pen.Visible := False;
  Chart1[0].HasZValues := True;

  Chart1.Axes.Left.Grid.Visible := False;
  Chart1.Axes.Bottom.Grid.Visible := False;
  Chart1.Axes.Top.Grid.Visible := False;
  Chart1.Axes.Right.Grid.Visible := False;

  Chart1.Axes.Left.Visible := False;
  Chart1.Axes.Bottom.Visible := True;
  Chart1.Axes.Top.Visible := True;
  Chart1.Axes.Right.Visible := True;

  //....................................................
  //...Steema fix for image axis labels
  //...
  Chart1[0].VertAxis := aBothVertAxis;
  Chart1[0].HorizAxis := aBothHorizAxis;
  //....................................................

  Chart1.Axes.Top.Increment := 0.1;
  Chart1.Axes.Bottom.Increment := 0.1;
  Chart1.Axes.Right.Increment := 1.0;

  Chart1.Axes.Left.LabelStyle:=talText;
  Chart1.Axes.Bottom.LabelStyle:=talValue;

  //...
  //... Axis Labels
  //...
  Chart1.Axes.Top.Title.Font.Color := clBlack;
  Chart1.Axes.Top.Title.Caption := 'Azimuth';
  Chart1.Axes.Top.AxisValuesFormat := '###0.##';
  Chart1.Axes.Bottom.AxisValuesFormat := '###0.##';


  // Set y-axis increment
  Chart1.Axes.Left.AxisValuesFormat := '###0.##';

  Chart1.Axes.Right.Title.Font.Color := clBlack;
  Chart1.Axes.Right.Title.Caption := 'Frequency';
  Chart1.Axes.Right.AxisValuesFormat := '###0.##';
  Chart1.Axes.Right.LabelsOnAxis := True;
  Chart1.Axes.Right.LabelsAlternate := False;

  // Set up the palette
  (Chart1[0] as TColorGridSeries).UsePaletteMin := True;
  (Chart1[0] as TColorGridSeries).PaletteMin := PaletteMin;
  (Chart1[0] as TColorGridSeries).PaletteStep := PaletteIncr;
  (Chart1[0] as TColorGridSeries).PaletteSteps := PaletteSteps;
  (Chart1[0] as TColorGridSeries).UsePalette := True;
  (Chart1[0] as TColorGridSeries).UseColorRange := False;

  (Chart1[0] as TColorGridSeries).LegendEvery := 1;
  (Chart1[0] as TColorGridSeries).SmoothBitmap := False;
  (Chart1[0] as TColorGridSeries).CenteredPoints := False;
  (Chart1[0] as TColorGridSeries).IrregularGrid := False;

  // Clear the current palette colors.
  (Chart1[0] as TColorGridSeries).ClearPalette();

   // Get the increment size of the default palette index.
   l := Max(Length(DefaultColorPalette) div PaletteSteps, 1);

   m := 1;
   for k := 0 to PaletteSteps-1 do
     begin
       (Chart1[0] as TColorGridSeries).AddPalette(PaletteMin+(k)*PaletteIncr, DefaultColorPalette[m]);
       Inc(m,l);
       if m > High(DefaultColorPalette) then
         m := High(DefaultColorPalette)
     end;

  //...
  //...Set up the plot legend.
  //...
  // Display legend to the left of the plot.
  Chart1.Legend.Alignment := laLeft;
  Chart1.Legend.CustomPosition := False;

  // Always use point values in the legend
  Chart1.Legend.LegendStyle := lsValues;

  // Display legend color boxes as a continuous bar.
  Chart1.Legend.Symbol.Continuous := False;

  // Makes the box around the legend transparent.
  Chart1.Legend.Transparent := True;
  Chart1.Legend.ShadowSize := 0;

  // Display the legend for color plots.
  Chart1.Legend.Visible := True;
  Chart1.Legend.Repaint;

  //Chart1.Legend.Title := fsBold;
  Chart1.Legend.Title.Font.Color := clBlack;
  Chart1.Legend.Title.Caption := '   dB';

  //...
  //...Manually set up fake frequency step data here.
  //...
  SetLength(xData, 401);  // There are 401 samples per column in test data set
  for i := 0 to 400 do
    xData[i] := 2 + (i*0.01);

  //...
  //...Manually set up fake angle data here.
  //...
  //...Notice that 0 is in the middle!
  //...
  SetLength(AngleData, 500);
  for i := 0 to 199 do
    AngleData[i] := (i*0.01) + 358;

  //...Add zero crossing
  AngleData[200] := 0;

  j := 1;
  for i := 201 to 499 do
    begin
      AngleData[i] := j*0.01;
      inc(j);
    end;
end;


procedure TForm1.StopBtnClick(Sender: TObject);
begin
  Stopping := True;
end;


procedure TForm1.ExitBtnClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  SetLength(ImageData,0);
  SetLength(xData,0);
  SetLength(yData, 0)
end;

end.
